@echo off

:: 代码页更改为Unicode (UTF-8)
:: chcp 65001

:: 判断admin权限
REM  --> Check for permissions
    IF "%PROCESSOR_ARCHITECTURE%" EQU "amd64" (
>nul 2>&1 "%SYSTEMROOT%\SysWOW64\cacls.exe" "%SYSTEMROOT%\SysWOW64\config\system"
) ELSE (
>nul 2>&1 "%SYSTEMROOT%\system32\cacls.exe" "%SYSTEMROOT%\system32\config\system"
)

REM --> If error flag set, we do not have admin.
if '%errorlevel%' NEQ '0' (
    echo "please use administrator permission to run this script..."
    goto noAdmin
) else ( goto gotAdmin )

:gotAdmin
echo "current is administrtor permission..."

:checkWinVerion
set is_win7=0
FOR /F "tokens=3*" %%i IN ('reg query "HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion" /v ProductName ^| Find "ProductName"') DO set WIN_VER=%%i %%j

echo "windows version: " %WIN_VER%
echo %WIN_VER% | find "Windows 7" > nul
if %errorlevel% == 0 set is_win7=1

:: 切换当前目录为批处理命令路径本身
cd /d %~dp0

echo "Install sunrise5 winusb Device Driver..."

echo "Ignore Sunrise5 bootrom dfu serial number check"
REG ADD "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\usbflags" /v IgnoreHWSerNum36520510 /t REG_BINARY /d 01 /f
REG ADD "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\usbflags" /v IgnoreHWSerNum36521510 /t REG_BINARY /d 01 /f

echo "Ignore Sunrise5 bootrom dfu winusb WCID support check"
REG ADD "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\usbflags\365205102900" /v osvc /t REG_BINARY /d 00 /f
REG ADD "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\usbflags\365215102900" /v osvc /t REG_BINARY /d 00 /f

:: 签名认证
echo "Register cerrtification file Drobotics-Sunrise5-CA.cer"
call %SYSTEMROOT%\System32\certutil.exe -f -addstore "Root" build/Drobotics-Sunrise5-CA.cer
call %SYSTEMROOT%\System32\certutil.exe -f -addstore "TrustedPublisher" build/Drobotics-Sunrise5-CA.cer

echo "Install sunrise5 bl1/bl2/bl33 dfu winusb Driver..."
cd ./dfu_winusb

:: win7 & win10 pnputil option is different
IF %is_win7% == 1 (
    pnputil.exe -i -a dfu_winusb.inf
) ELSE (
    pnputil.exe /add-driver dfu_winusb.inf /install
)

cd /d %~dp0
echo "Current Path: " %cd%

echo "Install Sunrise5 Android fastboot & adb driver..."
cd ./android_winusb

:: win7 & win10 pnputil option is different
IF %is_win7% == 1 (
    pnputil.exe -i -a android_winusb.inf
) ELSE (
    pnputil.exe /add-driver android_winusb.inf /install
)

echo "Finish driver install"

cd /d %~dp0
echo "Current path: " %cd%

:noAdmin

pause
@echo on
